#include <QCoreApplication>
#include <qfileinfo.h>
#include <qdir.h>
#include <qstring.h>
#include <QFileInfoList>
#include <qdebug.h>
#include <qfile.h>
#include <qdatetime.h>
#define dir_name "gpswrok"

void cor_file(QFileInfo fi)
{
    if(!fi.suffix().compare("gpx",Qt::CaseInsensitive))
    {
        QDir quDir(fi.path());
        QDir ziDir=quDir;
        bool ok=true;
        if(!ziDir.cd(dir_name))
        {
            quDir.mkdir(dir_name);
            ok=ziDir.cd(dir_name);
        }
        if(ok)
        {
            QFile fii(fi.filePath());
            QFileInfo fiz(ziDir,fi.fileName());
            QFile fio(fiz.filePath());
            if(fii.open(QIODevice::ReadOnly|QIODevice::Text) && fio.open(QIODevice::WriteOnly|QIODevice::Text))
            {
                QString line;
                QTextStream stri(&fii);
                QTextStream stro(&fio);
                while(!stri.atEnd())
                {
                    line=stri.readLine();
                    int start=line.indexOf("<time>");
                    if(start>-1)
                    {
                        QString anfang=line.left(start+6);
                        QString datum=line.mid(start+6);
                        int zeit=datum.indexOf("T");
                        if(zeit>-1)
                        {
                            QString ende=datum.mid(zeit);
                            datum.truncate(zeit);
                            QDate olddt;
                            olddt =QDate::fromString(datum,"yyyy-MM-dd");
                            QDate newDt=olddt.addDays(7168);
                            QDate heute=QDate::currentDate();
                            if(newDt<=heute)
                            {
                                datum=newDt.toString("yyyy-MM-dd");
                                line=anfang;
                                line+=datum;
                                line+=ende;
                            }
                        }
                    }

                    stro << line<<"\n";
                }
                fii.close();
                fio.close();
            }

        }
    }

}
void cor_dir(QDir di)
{
    QFileInfoList fil(di.entryInfoList());
    foreach(QFileInfo fi,fil)
    {
        if(fi.isDir())
        {
            QString cmpName="/";
            cmpName+=dir_name;
            if(!fi.filePath().endsWith("/.")&& !fi.filePath().endsWith("/..")&&!fi.filePath().endsWith(cmpName))
            {
                QDir di(fi.filePath());
                cor_dir(di);
            }
        }

        else
            cor_file(fi);
    }

}
int main(int argc, char *argv[])
{
    QCoreApplication a(argc, argv);
    for(int i=1;i<argc;i++)
    {
        QFileInfo fi(argv[i]);
        if(fi.isDir())
        {
            QDir di(argv[i]);
            cor_dir(di);
        }
        else
            cor_file(fi);
    }
}
